using System;

namespace SlatedGameToolkit.Framework.Exceptions
{
    /// <summary>
    /// An exception that is thrown when an error occurs on the game framework level that shouldn't have occurred and is definitely considered a bug.
    /// </summary>
    internal class InternalFrameworkException : FrameworkException {
        const string ADDITIONAL_MESSAGE = "**This exception is a framework bug!**";
        public InternalFrameworkException() : base() {

        }

        public InternalFrameworkException(string message) : base(message + ' ' + ADDITIONAL_MESSAGE) {

        }
        
        public InternalFrameworkException(string message, Exception inner) : base(message + ' ' + ADDITIONAL_MESSAGE, inner) {
        }
    }
}