using System.Numerics;

namespace SlatedGameToolkit.Framework.Graphics.Render
{
    public interface IMoveable
    {
        /// <summary>
        /// A vector describing the position this object should move to.
        /// This is then used to smooth the movement to the intermediate renders.
        /// 
        /// </summary>
        /// <value>A vector describing the new position of the object by the end of the update.</value>
        Vector3 MoveTo { get; set; }


        /// <summary>
        /// The current position of the entity.
        /// </summary>
        /// <value>A vector describing the current objects position.</value>
        Vector3 Position { get; set; }
    }
}